#include <Adafruit_NeoPixel.h>

#define LED_PIN 6 // WS2812 的信號線接到 Arduino 的 6 號腳
#define LED_COUNT 24 // 燈帶的燈數
#define BUTTON_PIN 2 // 按鈕的信號線接到 Arduino 的 2 號腳

Adafruit_NeoPixel pixels(LED_COUNT, LED_PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  pixels.begin();
  pixels.show(); // 將所有燈關閉

  pinMode(BUTTON_PIN, INPUT); // 設定按鈕為輸入模式，不啟用內部上拉電阻
}

void loop() {
  static int count = 0;
  static int last_index = -1;

  if (count < 24) {
    // 隨機亮一顆燈
    int index = random(LED_COUNT);
    pixels.setPixelColor(index, pixels.Color(255, 0, 200)); // 紅色
    pixels.show();
    delay(100);

    // 關掉所有燈
    pixels.clear();
    pixels.show();
    
    last_index = index;
    count++;
  } else {
    // 停在一顆燈
    pixels.setPixelColor(last_index, pixels.Color(255,0, 10)); // 綠色
    pixels.show();

    // 等待按鈕被按下
    while (digitalRead(BUTTON_PIN) == HIGH) {
      delay(10);
    }

    // 重置計數器
    count = 0;
  }
}
